// Convert Notation with * to normal siteswap notation
// (c) L.Klam

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#define VERSION "5.6.06"

// #define COMPILE_SOLO

#define max_len 100

enum { STAR_STANDARD, STAR_SOLO };

#ifndef COMPILE_SOLO
	#include "protos.h"
	extern struct OPTIONS options;
#endif

void star_delete_brackets(char str[])
{
	unsigned int i,j=0;

	for(i=0;i<=strlen(str);i++)
	{
		if ((isalnum(str[i]))||(str[i]=='[')||(str[i]==']')||(str[i]=='.')||(str[i]=='\0')) {
			str[j]=str[i];
			j++;
		}
	}
}

int star_test_throw(char str[], int pos, int standard)
{
	if ((pos>0)&&(str[pos-1]=='.'))	return 0;
	if (isdigit(str[pos])) return 1;
	if ((standard)&&(str[pos]>='a')&&(str[pos]<='v')) return 1;
	if ((!standard)&&(str[pos]>='a')&&(str[pos]<='o')) return 1;
	return 0;
}

void star_convert(char str[], char erg[], int standard)
{

	// standard = STAR_STANDARD, STAR_SOLO

	int str_len;
	int zeiger[3];
	int pos,i;
	int status; //number of open brackets [] -> multiplex

	star_delete_brackets(str); //eliminate "(),*"

#ifdef COMPILE_SOLO
	printf("simplified: %s*\n",str);
#endif

	str_len=strlen(str);
	strcpy(erg,str);

	status=0;
	i=-1;

	for(pos=0;pos<=str_len;pos++)
	{
		if ((status<=0)&&((str[pos]=='[')||(str[pos]=='\0')||(star_test_throw(str,pos,standard)))) {
			i++;
			zeiger[i]=pos;
			if (i==2) {
				//add swapped strings
				strncat(erg,&str[zeiger[1]],zeiger[2]-zeiger[1]);
				strncat(erg,&str[zeiger[0]],zeiger[1]-zeiger[0]);

				zeiger[0]=zeiger[2];
				i=0;
			}
		}

		if (str[pos]=='[') status++;
		if (str[pos]==']') status--;
	}

#ifndef COMPILE_SOLO
	if (options.debug)
		printf("%s -> %s\n",str,erg);
#endif

}

#ifdef COMPILE_SOLO
int main(int argc, char *argv[])
{
	char str[max_len+1];
	char erg[2*(max_len+1)];

//	strcpy(str,"([6,4],[8,2])*");
	strcpy(str,"6xs*");

	star_convert(str,erg,STAR_STANDARD /*STAR_SOLO*/);

	printf("%s* -> %s\n",str,erg);

}
#endif